/******************************************************************************
*
* TI Clock Basic Set, programmed by Johannes Zeppenfeld
* Sets time and date. Now Basic can set the clock!
*
* cti_set(hours,minutes,seconds,month,day,year)
*******************************************************************************
* For use with the ClockTi TSR
*******************************************************************************
* You may use this code however you like, but please give credit to those who
* wrote it.
* Other than that, this code is e-note-ware: if you use it, please send me an
* email telling me about your project and how you integrated the clock into it.
* I love to hear what others use programs I write for.
* Johannes Zeppenfeld (jzeppenfeld@excite.com)
******************************************************************************/
#define USE_TI89              // Produce .89z File
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#include <tigcclib.h>         // Include All Header Files

const unsigned short numDays[]={31,28,31,30,31,30,31,31,30,31,30,31};
// Main Function
void _main(void) {
	ESI argptr;
	int argtype;
	unsigned short i=0, array[7];
	char *td = (char *)(peek_l(0x94));
	if((unsigned long)td>=0x200000) {
		DlgMessage("ERROR","TSR Not Installed",BT_CANCEL,BT_NONE);
		return;
	}

	InitArgPtr(argptr);
	while(i<7 && (argtype = GetArgType(argptr)) != END_TAG) {
		if(argtype == POSINT_TAG) {
			array[i] = GetIntArg(argptr);
			i++;
		} else {
			DlgMessage("ERROR","Invalid Argument",BT_CANCEL,BT_NONE);
			return;
		}
 	}
 	if(i!=6) {
			DlgMessage("ERROR","Wrong Number of Arguments",BT_CANCEL,BT_NONE);
		return;
 	}
	while(array[2]>59) {
		array[1]++;
		array[2]-=60;
	}
	while(array[1]>59) {
		array[0]++;
		array[1]-=60;
	}
	while(array[0]>23) {
		array[4]++;
		array[0]-=24;
	}
	while(array[3]>12) {
		array[5]++;
		array[3]-=12;
	}
	if(!array[3]) array[3]=1;
	if(!array[4]) array[4]=1;
	while(array[4]>(i=numDays[array[3]-1]+(array[3]==2&&!(array[5]%4)))) {
		array[4]-=i;
		array[3]++;
		if(array[3]>12) {
			array[5]++;
			array[3]-=12;
		}
	}
	if(array[5]>99) array[5]=99;
	for(i=1; i<6; i++) {
		td[2*i+1]=array[i];
	}
	td[1]=array[2];
	td[5]=array[0];
}
