/******************************************************************************
*
* TI Clock Time to String, programmed by Johannes Zeppenfeld
* Returns the time as a string. Now Basic can read the clock!
*
*******************************************************************************
* For use with the ClockTi TSR
*******************************************************************************
* You may use this code however you like, but please give credit to those who
* wrote it.
* Other than that, this code is e-note-ware: if you use it, please send me an
* email telling me about your project and how you integrated the clock into it.
* I love to hear what others use programs I write for.
* Johannes Zeppenfeld (jzeppenfeld@excite.com)
******************************************************************************/
#define USE_TI89              // Produce .89z File
#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization
#define RETURN_VALUE // t			// uncomment t to return variable
#include <tigcclib.h>         // Include All Header Files

// Main Function
void _main(void) {
	char ret[20];
	char *td = (char *)(peek_l(0x94));
	if((unsigned long)td>=0x200000) {
		push_expr_quantum($(TSR Not Installed), STR_TAG);
	} else {
		sprintf(ret,"%02d:%02d:%02d",td[5],td[3],td[1]);
		push_ANSI_string(ret);
	}
}
